import { calculateWinner } from '../services/example';

export default {
  namespace: 'game',

  state: {
    history: [
      {
        squares: Array(9).fill(null)
      }
    ],
    stepNumber: 0,
    xIsNext: true
  },

  reducers: {
    handleClick(state, action){
      const history = state.history.slice(0, state.stepNumber + 1);
      const current = history[history.length - 1];
      const squares = current.squares.slice();
      if (calculateWinner(squares) || squares[action.payload]) {
        return {...state};
      }
      squares[action.payload] = state.xIsNext ? "X" : "O";
      return {
        history: history.concat([
          {
            squares: squares
          }
        ]),
        stepNumber: history.length,
        xIsNext: !state.xIsNext
      };
    },
    jumpTo(state, action){
      return {
        ...state,
        stepNumber: action.payload,
        xIsNext: (action.payload % 2) === 0
      }
    }
  },

};
